  .section    .boot, "ax", @progbits

.global _start
_start:
    j _entry

.org 0x8

.extern trap_entry
_exception_entry:
  j trap_entry


_entry:
	
  lui	t0,%hi(0x86000000)
  lw	t0,%lo(0x86000000)(t0)
  and t0, t0, 1	
  bnez	t0, _recovery
  lui	t0,%hi(0x86000000)
  li t1, 1
  sw  t1, 0(t0)
	
  lui ra, 0
  lui sp, 0
  lui gp, 0
  lui tp, 0
  lui s0, 0
  lui s1, 0
  lui s2, 0
  lui s3, 0
  lui s4, 0
  lui s5, 0
  lui s6, 0
  lui s7, 0
  lui s8, 0
  lui s9, 0
  lui s10, 0
  lui s11, 0
  lui t0, 0
  lui t1, 0
  lui t2, 0
  lui t3, 0
  lui t4, 0
  lui t5, 0
  lui t6, 0 
  lui a0, 0
  lui a1, 0
  lui a2, 0
  lui a3, 0
  lui a4, 0
  lui a5, 0
  lui a6, 0
  lui a7, 0
  la gp, _gp                 /* Initialize global pointer */
  la sp, _fstack

/*  la t0, _fexception_stack
  csrrw t0, mscratch, t0 */

  /* clear the bss segment */
  la t0, _fbss
  la t1, _end
1:
#ifdef __riscv64
  sd zero,0(t0)
  addi t0, t0, 8
#else
  sw zero,0(t0)
  addi t0, t0, 4
#endif
  bltu t0, t1, 1b
  call main
1:
  j     1b

_recovery:
	la	t0, _recov_data
	sw	ra, 0(t0)	# x1
	lw	ra, 0(t0)
	sw	sp, 0(t0)	# x2
	lw	sp, 0(t0)
	sw	gp, 0(t0)	# x3
	lw	gp, 0(t0)
	sw	tp, 0(t0)	# x4
	lw	tp, 0(t0)
	li	t1, 0		# x6
	li	t2, 0		# x7
	sw	s0, 0(t0)	# x8
	lw	s0, 0(t0)
	sw	s1, 0(t0)	# x9
	lw	s1, 0(t0)
	li	a0, 0		# x10
	li	a1, 0		# x11
	li	a2, 0		# x12
	li	a3, 0		# x13
	li	a4, 0
	li	a5, 0
	li	a6, 0
	li	a7, 0		# x17
	sw	s2, 0(t0)	# x18
	lw	s2, 0(t0)
	sw	s3, 0(t0)	# x19
	lw	s3, 0(t0)
	sw	s4, 0(t0)	# x20
	lw	s4, 0(t0)
	sw	s5, 0(t0)	# x21
	lw	s5, 0(t0)
	sw	s6, 0(t0)	# x22
	lw	s6, 0(t0)
	sw	s7, 0(t0)	# x23
	lw	s7, 0(t0)
	sw	s8, 0(t0)	# x24
	lw	s8, 0(t0)
	sw	s9, 0(t0)	# x25
	lw	s9, 0(t0)
	sw	s10, 0(t0)	# x26
	lw	s10, 0(t0)
	sw	s11, 0(t0)	# x27
	lw	s11, 0(t0)
	li	t3, 0		# x28
	li	t4, 0		# x29
	li	t5, 0		# x30
	li	t6, 0		# x31
	li	t0, 0
	ret
	.data
_recov_data:	.long 0
