#include <stdio.h>
#include <string.h>
#include "eth_config.h"
#include "uart.h"





void eth_send_frame(uint16_t len);

void __attribute__((optimize("O0"))) delay_us(uint16_t us) {
	uint32_t istrs = ((uint16_t) us ) << 5;
	while (istrs > 0)
		istrs--;

}



volatile uint32_t __attribute__((section (".dma"))) rx_buf0[1516/4];
volatile uint32_t __attribute__((section (".dma"))) rx_buf1[1516/4];


volatile uint32_t tx_buf[1516/4];

static volatile eth_descriptor * rx_descriptor0 = (volatile void *) MAC_REG_RXDESCRIPTOR0;
static volatile eth_descriptor * rx_descriptor1 = (volatile void *) MAC_REG_RXDESCRIPTOR1;
static volatile eth_descriptor * tx_descriptor  = (volatile void *) MAC_REG_TXDESCRIPTOR; 
static volatile uint32_t * mac_config = (volatile void *) MAC_REG_CONFIG;

volatile uint32_t * miim_config = (volatile uint32_t *) MAC_REG_MIICONFIG;
volatile uint32_t * miim_reg =  (volatile uint32_t *) MAC_REG_MII;

void reset_phy (void) {

	*mac_config = 0x10;
	delay_us(175);
	*mac_config = 0x8;
	delay_us(100);	
}

void disable_irq () {
	unsigned t;
	asm volatile ("csrrci %0, mstatus, %1" : "=r"(t) : "i"(1 << 3));
}

void enable_irq () {
	unsigned t;
  	asm volatile ("csrrsi %0, mstatus, %1" : "=r"(t) : "i"(1 << 3));
}

void init_mac (void) {

		
	disable_irq();
  		
	*mac_config = MAC_RESET;
	delay_us(1);
	*mac_config = MAC_INIT_CONFIG;

	rx_descriptor0->busy = 1;
	rx_descriptor1->busy = 1;
	tx_descriptor->busy = 0;
	
	*mac_config = MAC_ENABLE_TX | MAC_ENABLE_RX;

	enable_irq();

	print_string("mac init done\n");

}


uint32_t link_status = 0;

void link_check (void) {
uint8_t result;


		
	*miim_config = 1;
	while(! (*miim_reg & 0x80000000));

 	if (*miim_reg & 0x700)
		return;

	if ( (*miim_reg & 0x4))
		result = 1;
	else 
		result = 0;

	if (result == 1 && link_status == 0) {
		init_mac();
		print_string("link up\n");
	
	link_status = result;
	}

	if (result == 0 && link_status == 1) {
		print_string("link dn\n");
		//*mac_config = 0;
		
		link_status = result;
		reset_phy();
	}	
	
	
	

}



volatile uint32_t int_phy_reset = 0;
volatile uint32_t int_tx_done = 0;

uint8_t eth_loop ()
{
	link_check();
}


uint32_t packets_sent = 0;

void eth_send_frame (uint16_t len) {

	int i = 0;
	tx_descriptor->len = len;
	tx_descriptor->addr = 0xffff & (uint32_t)tx_buf;
	tx_descriptor->busy = 1;

	packets_sent++;

	
}


void irq_handler(void)
{
	uint16_t len = 0;
	volatile eth_descriptor * irq_descriptor;



	if (tx_descriptor->irq) {
		asm("nop"); 
		int_tx_done = 1;
	}
	
	if (rx_descriptor0->irq)
		irq_descriptor = rx_descriptor0;
	else if (rx_descriptor1->irq) 
		irq_descriptor = rx_descriptor1;

	len  = irq_descriptor->len - 4;
	if (len > 1512) while(1) print_word(0xBADBAD00);


	memcpy ((void *) tx_buf, (void *) irq_descriptor->addr, len);


	if (len > 10)
		eth_send_frame (len);

         irq_descriptor->busy = 1;

	
     


}





