#include <stdio.h>
#include "riscv.h"
#include "eth_config.h"
#include "uart.h"
#include "string.h"



uint32_t memtest_buffer [4096];

unsigned int memtest () {
	int i = 0;
	unsigned int res = 0;
	
	while (i < sizeof(memtest_buffer) >> 2) {
		res = res ^ memtest_buffer [i];
		memtest_buffer[i++] = 0xAAAAAAAA;
	}
		
	return res;	
	
	
}






unsigned int cnt;


char * startup = "Fresh startup!\n";

void main(void)
{
unsigned int proc_counter,counter = 0;

volatile int * p_seu = (void*) 0x83000000;
volatile char  * p_wd = (void*) 0x81000000;
volatile uint32_t * supervisor = (volatile) (uint32_t *) 0x86000000;

int bert_started = 0;
uint32_t bert_counter = 0;

print_string("\n\n\n\n");

print_string(startup);
print_line();

// in case of random PC reset, change content of heap memory to show it
startup[0] = 'R';
startup[1] = 'R';
startup[2] = 'R';


print_string("M2S090\n");
print_line();
print_string(__DATE__);
print_line();
print_string(__TIME__);
print_line();


reset_phy(); 
init_mac();

unsigned t;
asm volatile ("csrrci %0, mstatus, %1" : "=r"(t) : "i"(1 << 3));


// Enable irq: set mie.meie
asm volatile ("csrrs %0, mie, %1" : "=r"(t) : "r"(1 << 11));
asm volatile ("csrrsi %0, mstatus, %1" : "=r"(t) : "i"(1 << 3));

*p_wd = 1; //watchdog





while (1) 

{
	uint32_t seu;
	counter++;	

	if (counter & 0x8000) {
		counter = 0;
		proc_counter++;

		seu = *p_seu++;
		print_string("cnt: ");
		print_word(proc_counter);
		print_string(" seu iram: ");
		print_word(seu);

		seu = *p_seu;
		print_string(" seu dram: ");
		print_word(seu);
		
		print_string(" mem: ");
		print_word(memtest());
		print_line();

	}



	eth_loop ();
	refresh ();
	uint32_t cpu_status = (*supervisor >> 16) & 0x7;
	if (cpu_status != 7) {
		print_string ("cpu not aligned!\n");
		asm volatile ("csrrci %0, mstatus, %1" : "=r"(t) : "i"(1 << 3));
		*supervisor = 2; // recovery
  		asm volatile ("csrrsi %0, mstatus, %1" : "=r"(t) : "i"(1 << 3));
  		asm volatile ("csrrs %0, mie, %1" : "=r"(t) : "r"(1 << 11));
	}




	*p_wd = 1;

}


}
