OUTPUT_FORMAT("elf32-littleriscv")
ENTRY(_start)

MEMORY
{
   iram : ORIGIN = 0x00000000, LENGTH = 512
   ldr  : ORIGIN = 0x00000200, LENGTH = 512
   dram : ORIGIN = 0x00010000, LENGTH = 64K

}


SECTIONS
{

  /* Begining of code and text segment */
  . = 0x00000000;
  /* text: Program code section */
  .text :
  {
    *(.boot)
    *(.text)
    *(.text.*)
    *(.gnu.linkonce.t.*)

  } > iram
  .loader :
  {
    *(.launcher)
    *(.launcher.*)
    *(.launcher_call)
  } > ldr

  /* rodata: Read-only data */
  .data :
  {
    *(.rdata)
    *(.rodata)
    *(.rodata.*)
    *(.gnu.linkonce.r.*)
    *(.data)
    *(.data.*)
    
    *(.gnu.linkonce.d.*)
    _edata = .;

    /* Have _gp point to middle of sdata/sbss to maximize displacement range */
    . = ALIGN(16);
    _gp = . + 0x800;

    *(.sdata)
    *(.sdata.*)
    *(.srodata.*)
    *(.gnu.linkonce.s.*)

    . = ALIGN(8);
    _fbss = .;

    *(.sbss)
    *(.sbss.*)
    *(.gnu.linkonce.sb.*)

    _bss_start = .;

    *(.bss)
    *(.bss.*)
    *(.gnu.linkonce.b.*)
    *(COMMON)

    _end = ALIGN(8);
  } > dram

 PROVIDE(_fstack = ORIGIN(dram) + LENGTH(dram) - 0x100);

}
